# Generated by the protocol buffer compiler.  DO NOT EDIT!
# Source: google/cloud/domains/v1beta1/domains.proto for package 'google.cloud.domains.v1beta1'
# Original file comments:
# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

require 'grpc'
require 'google/cloud/domains/v1beta1/domains_pb'

module Google
  module Cloud
    module Domains
      module V1beta1
        module Domains
          # The Cloud Domains API enables management and configuration of domain names.
          class Service

            include ::GRPC::GenericService

            self.marshal_class_method = :encode
            self.unmarshal_class_method = :decode
            self.service_name = 'google.cloud.domains.v1beta1.Domains'

            # Searches for available domain names similar to the provided query.
            #
            # Availability results from this method are approximate; call
            # `RetrieveRegisterParameters` on a domain before registering to confirm
            # availability.
            rpc :SearchDomains, ::Google::Cloud::Domains::V1beta1::SearchDomainsRequest, ::Google::Cloud::Domains::V1beta1::SearchDomainsResponse
            # Gets parameters needed to register a new domain name, including price and
            # up-to-date availability. Use the returned values to call `RegisterDomain`.
            rpc :RetrieveRegisterParameters, ::Google::Cloud::Domains::V1beta1::RetrieveRegisterParametersRequest, ::Google::Cloud::Domains::V1beta1::RetrieveRegisterParametersResponse
            # Registers a new domain name and creates a corresponding `Registration`
            # resource.
            #
            # Call `RetrieveRegisterParameters` first to check availability of the domain
            # name and determine parameters like price that are needed to build a call to
            # this method.
            #
            # A successful call creates a `Registration` resource in state
            # `REGISTRATION_PENDING`, which resolves to `ACTIVE` within 1-2
            # minutes, indicating that the domain was successfully registered. If the
            # resource ends up in state `REGISTRATION_FAILED`, it indicates that the
            # domain was not registered successfully, and you can safely delete the
            # resource and retry registration.
            rpc :RegisterDomain, ::Google::Cloud::Domains::V1beta1::RegisterDomainRequest, ::Google::Longrunning::Operation
            # Lists the `Registration` resources in a project.
            rpc :ListRegistrations, ::Google::Cloud::Domains::V1beta1::ListRegistrationsRequest, ::Google::Cloud::Domains::V1beta1::ListRegistrationsResponse
            # Gets the details of a `Registration` resource.
            rpc :GetRegistration, ::Google::Cloud::Domains::V1beta1::GetRegistrationRequest, ::Google::Cloud::Domains::V1beta1::Registration
            # Updates select fields of a `Registration` resource, notably `labels`. To
            # update other fields, use the appropriate custom update method:
            #
            # * To update management settings, see `ConfigureManagementSettings`
            # * To update DNS configuration, see `ConfigureDnsSettings`
            # * To update contact information, see `ConfigureContactSettings`
            rpc :UpdateRegistration, ::Google::Cloud::Domains::V1beta1::UpdateRegistrationRequest, ::Google::Longrunning::Operation
            # Updates a `Registration`'s management settings.
            rpc :ConfigureManagementSettings, ::Google::Cloud::Domains::V1beta1::ConfigureManagementSettingsRequest, ::Google::Longrunning::Operation
            # Updates a `Registration`'s DNS settings.
            rpc :ConfigureDnsSettings, ::Google::Cloud::Domains::V1beta1::ConfigureDnsSettingsRequest, ::Google::Longrunning::Operation
            # Updates a `Registration`'s contact settings. Some changes require
            # confirmation by the domain's registrant contact .
            rpc :ConfigureContactSettings, ::Google::Cloud::Domains::V1beta1::ConfigureContactSettingsRequest, ::Google::Longrunning::Operation
            # Exports a `Registration` that you no longer want to use with
            # Cloud Domains. You can continue to use the domain in
            # [Google Domains](https://domains.google/) until it expires.
            #
            # If the export is successful:
            #
            # * The resource's `state` becomes `EXPORTED`, meaning that it is no longer
            # managed by Cloud Domains
            # * Because individual users can own domains in Google Domains, the calling
            # user becomes the domain's sole owner. Permissions for the domain are
            # subsequently managed in Google Domains.
            # * Without further action, the domain does not renew automatically.
            # The new owner can set up billing in Google Domains to renew the domain
            # if needed.
            rpc :ExportRegistration, ::Google::Cloud::Domains::V1beta1::ExportRegistrationRequest, ::Google::Longrunning::Operation
            # Deletes a `Registration` resource.
            #
            # This method only works on resources in one of the following states:
            #
            # * `state` is `EXPORTED` with `expire_time` in the past
            # * `state` is `REGISTRATION_FAILED`
            rpc :DeleteRegistration, ::Google::Cloud::Domains::V1beta1::DeleteRegistrationRequest, ::Google::Longrunning::Operation
            # Gets the authorization code of the `Registration` for the purpose of
            # transferring the domain to another registrar.
            #
            # You can call this method only after 60 days have elapsed since the initial
            # domain registration.
            rpc :RetrieveAuthorizationCode, ::Google::Cloud::Domains::V1beta1::RetrieveAuthorizationCodeRequest, ::Google::Cloud::Domains::V1beta1::AuthorizationCode
            # Resets the authorization code of the `Registration` to a new random string.
            #
            # You can call this method only after 60 days have elapsed since the initial
            # domain registration.
            rpc :ResetAuthorizationCode, ::Google::Cloud::Domains::V1beta1::ResetAuthorizationCodeRequest, ::Google::Cloud::Domains::V1beta1::AuthorizationCode
          end

          Stub = Service.rpc_stub_class
        end
      end
    end
  end
end
